import { select, csv, scaleLinear, max, scaleBand } from 'd3';

// selecteer het svg element
// in html
const svg	= select('svg');

// zet de waardes vanuit html attribute van
// string naar int
const width		= +svg.attr('width');
const height	= +svg.attr('height');

// Toon een staaf per rij
// van de dataset
const render	= data => {
  
	// variabele voor DRY   
  const xValue	= kolom2 => kolom2["Aantal oplaadpunten"];
  const yValue	= kolom1 => kolom1["Steden in de randstad"];
  
   
//   const xScale	= scaleLinear()
//   	.domain([0, max(data, kolom2 => kolom2["Aantal oplaadpunten"])])
//   	.range([0, width]);
  
//   const yScale	= scaleBand()
//   	.domain(data.map(kolom1 => kolom1["Steden in de randstad"]))
//   	.range([0, height]);  
  
  // update met DRY variabele uit dataset   
  const xScale	= scaleLinear()
  	.domain([0, max(data, xValue)])
  	.range([0, width]);
  
  const yScale	= scaleBand()
  	.domain(data.map(yValue))
  	.range([0, height]);
  
  
  // log resultaat van domain & range
  console.log("Domain X", xScale.domain());
  console.log("Range X", xScale.range());
  console.log("Domain Y", yScale.domain());

  // maak d.m.v. een data join 'enter' rechthoeken
  // & voeg deze toe aan het svg element
  // omdat bij aanvang geen rect op de svg aanwezig    
  // moet er gebruik worden gemaakt van selectAll    
//   svg.selectAll('rect').data(data)
//     .enter().append('rect')
//       .attr('width', 300)
//       .attr('height', 300);
// };  

// update: met waarde uit dataset  
// 	svg.selectAll('rect').data(data)
//     .enter().append('rect')
//   		.attr('y', kolom1 => yScale(kolom1["Steden in de randstad"]))
//       .attr('width', kolom2 => xScale(kolom2["Aantal oplaadpunten"]))
//       .attr('height', yScale.bandwidth());
// };  

  // update met DRY variabele uit dataset   
	svg.selectAll('rect').data(data)
    .enter().append('rect')
  		.attr('y', kolom1 => yScale(yValue(kolom1)))
      .attr('width', kolom2 => xScale(xValue(kolom2)))
      .attr('height', yScale.bandwidth());
};

// lees data in via de csv Promise 
csv('data.csv').then(data => { 
  
	// conventeer de waarde van een aatal properties naar int waarde  
  data.forEach(property => {
  	property["Aantal oplaadpunten"] = +property["Aantal oplaadpunten"];
  	// property["Aantal parkeer garages"] = +property["Aantal parkeer garages"];
  });
  
  render(data);
  
});

